#ifndef CONFIG_H_
#define CONFIG_H_

#include "FS.h"
#include "LittleFS.h"
#include <ArduinoJson.h>

typedef struct {
  const char *ssid;
  const char *psk;
  const char *mqtt_host;
  const char *mqtt_user;
  const char *mqtt_password;
  const char *topic;
  const char *device_id;
  int mqtt_port;
  long sleep_time;
  int connection_attempts;
} Config;

void initialize_config(Config *config, StaticJsonDocument<512> json);

bool load_config_file(const char *file_path, Config *config);

long minutes_to_microseconds(int minutes);

#endif // CONFIG_H_
